#ifndef TABLA_CODEC_DIGITAL_HEDSET_H

#define TABLA_CODEC_DIGITAL_HEDSET_H

#define	AUDIOIF_E_OK				(0)
#define	AUDIOIF_E_OK_NOMIC			(0)
#define	AUDIOIF_E_OK_USEMIC			(1)
#define	AUDIOIF_E_OK_BEFORESTART	(2)
#define	AUDIOIF_E_NG				(-1)
#define	AUDIOIF_E_DEVICE			(-2)

#define	AUDIOIF_DEVICE_USB			(1)

#define	AUDIOIF_DETECT_INSERT		(1)
#define	AUDIOIF_DETECT_REMOVE		(2)

#define	AUDIOIF_IRQ_INS_PLUG		(1)
#define	AUDIOIF_IRQ_REM_PLUG		(2)
#define	AUDIOIF_IRQ_MIC_SWITCH_ON	(3)
#define	AUDIOIF_IRQ_MIC_SWITCH_OFF	(4)
#define	AUDIOIF_IRQ_HEDSET			(5)
#define	AUDIOIF_IRQ_TYPE			(0x0f)
#define	AUDIOIF_IRQ_CONNECT			(0x0010)
#define	AUDIOIF_IRQ_CALLBACK		(0x0020)
#define	AUDIOIF_IRQ_HEDSET_NOMIC	(0x0100)
#define	AUDIOIF_IRQ_HEDSET_MIC		(0x0200)
#define	AUDIOIF_IRQ_HEDSET_MONO		(0x1000)
#define	AUDIOIF_IRQ_HEDSET_STEREO	(0x2000)

#define	AUDIOIF_IRQ_INSERT			(AUDIOIF_IRQ_INS_PLUG | AUDIOIF_IRQ_CONNECT)
#define	AUDIOIF_IRQ_INSERT_CALLBACK	(AUDIOIF_IRQ_INS_PLUG | AUDIOIF_IRQ_CONNECT | AUDIOIF_IRQ_CALLBACK)
#define	AUDIOIF_IRQ_INSERT_NOMIC	(AUDIOIF_IRQ_INS_PLUG | AUDIOIF_IRQ_HEDSET_NOMIC)
#define	AUDIOIF_IRQ_REMOVE			(AUDIOIF_IRQ_REM_PLUG)
#define	AUDIOIF_IRQ_REMOVE_CALLBACK	(AUDIOIF_IRQ_REM_PLUG | AUDIOIF_IRQ_CONNECT | AUDIOIF_IRQ_CALLBACK)
#define	AUDIOIF_IRQ_MIC_ON			(AUDIOIF_IRQ_MIC_SWITCH_ON | AUDIOIF_IRQ_CONNECT)
#define	AUDIOIF_IRQ_MIC_OFF			(AUDIOIF_IRQ_MIC_SWITCH_OFF | AUDIOIF_IRQ_CONNECT)
#define	AUDIOIF_IRQ_HS_MONO_NONE	(AUDIOIF_IRQ_HEDSET | AUDIOIF_IRQ_HEDSET_NOMIC | AUDIOIF_IRQ_HEDSET_MONO)
#define	AUDIOIF_IRQ_HS_STEREO_NONE	(AUDIOIF_IRQ_HEDSET | AUDIOIF_IRQ_HEDSET_NOMIC | AUDIOIF_IRQ_HEDSET_STEREO)
#define	AUDIOIF_IRQ_HS_MONO_USE		(AUDIOIF_IRQ_HEDSET | AUDIOIF_IRQ_HEDSET_MIC | AUDIOIF_IRQ_HEDSET_MONO)
#define	AUDIOIF_IRQ_HS_STEREO_USE	(AUDIOIF_IRQ_HEDSET | AUDIOIF_IRQ_HEDSET_MIC | AUDIOIF_IRQ_HEDSET_STEREO)

int hedset_detect_callback(int, int, void**);
int hedset_detect_irq(int, int);
int hedset_detect_mictype(int);

#endif
